/* Cours "Methodes Numeriques" L3 paris 7                */
/* Annee 2006 - jacques Le Bourlot                       */
/*    Resolution de f(x) = 0 par Newton                  */

#include <math.h>
#include <stdio.h>
#include <stdlib.h>

int newt(double *, double *, double, double (*f1) (double), double (*fp1) (double)) ;

/*--------------------------------------------------------*/

int newt(double *x, double *f, double eps, double (*f1) (double), double (*fp1) (double)) {

  int flag, j ;
  int nmax = 25 ;
  double xt, dx ;

  for (flag=0, j=0; flag==0; j++) {

/* Nouveau point                                         */

    xt = *x - f1(*x) / fp1(*x) ;
    *f = f1(xt) ;

    printf (" %2d fp(%15.10le) = %8.2le \n", j+1, xt, *f) ;

/* Test de convergence                                   */

    if (xt != 0.0) {
      dx = fabs((xt- *x)/xt) ;
    } else {
      dx = fabs(xt- *x) ;
    }
    if (dx < eps && fabs(*f) < eps) {
      flag = 1 ;
    } else if (j>nmax) {
      flag = 2 ;
    }
    *x = xt ;
  }

  return flag ;

}
