/* Cours "Methodes Numeriques" L3 paris 7                */
/* Annee 2006 - jacques Le Bourlot                       */
/*    Resolution de f(x) = 0 par Newton                  */

#include <math.h>
#include <stdio.h>
#include <stdlib.h>

/* Declarations globales */

double a = 1.0 ;
double r = 5.0 ;
double b = 150.0 ;

double fp(double) ;
double fpp(double) ;
int newt(double *, double *, double, double (*f1) (double), double (*fp1) (double)) ;

/*--------------------------------------------------------*/

double fp(double x) {
/* Derivee de la courbe de potentiel                      */
/* f_pot(x) = a * exp(x/r) - b / x**6                     */
  double ff ;

  ff = -a*r * exp(r/x) / (x*x) + 6.0*b / exp(7.0*log(x)) ;

  return ff ;
}

/*--------------------------------------------------------*/

double fpp(double x) {
/* Derivee de la derivee de la courbe de potentiel        */
/* f_pot(x) = a * exp(x/r) - b / x**6                     */
/* fp = -a*r * exp(r/x) / (x*x) + 6.0*b / exp(7.0*log(x)) */
  double ff ;

  ff = a*r*r * exp(r/x) / (x*x*x*x) + 2.0*a*r * exp(r/x) / (x*x*x) - 6.0*7.0*b / exp(8.0*log(x)) ;

  return ff ;
}

/*--------------------------------------------------------*/

int main ()
{
  double x1 ;         /* Valeur courante             */
  double f1 ;         /* Valeur de la fn en x1       */
  double eps ;        /* Precision                   */
  int etat ;          /* "Flag" : statut actuel      */

/* Initialisation                                    */

  printf (" Entrer point de depart\n") ;
  scanf ("%lf", &x1) ;
  f1 = fp(x1) ;
  printf (" fp(%g) = %g\n", x1, f1) ;

  printf (" Entrer la precision demandee\n") ;
  scanf ("%lf", &eps) ;
  printf (" eps = %g\n\n", eps) ;

/* Appel a newt                                          */

   etat = newt (&x1, &f1, eps, fp, fpp) ;

  if (etat == 1) {
    printf ("\n x = %20.14lf, fp(x) = %15.9le\n", x1, f1) ;
  } else if (etat == 2) {
    printf ("\n\n Maximum iterations atteint!\n") ;
    printf ("\n x = %20.14lf, fp(x) = %15.9le\n", x1, f1) ;
  } else {
    printf ("\n\n Vous avez un probleme!\n") ;
    return 1 ;
  }

  return 0 ;
}
